#include <X11/Xlib.h>
//#include <X11/xpm.h>
#include <stdio.h>

// The image data here is assumed to be 24 bits per pixel, left to right, top to bottom, no padding
int displayX11(unsigned int wid, unsigned int hei, const unsigned char* imageData) {
	Display *d;
	Window w;
	XEvent e;
	int s;

	Pixmap image;
 
	int a, b;

	d = XOpenDisplay(NULL);
	if (d == NULL) {
		fprintf(stderr, "Cannot open display\n");
		return 1;
	}
 

/*
 	if(XpmCreatePixmapFromData(d, RootWindow(d, s), pixmapData, &image, NULL, NULL) != XpmSuccess) {
		fprintf(stderr, "fuck");
		return 1;
	}
*/


	s = DefaultScreen(d);
 
	w = XCreateSimpleWindow(d, RootWindow(d, s), 0, 0, wid, hei, 1,
		BlackPixel(d, s), WhitePixel(d, s));
 
	image = XCreatePixmap(d, w, wid, hei, 24);

	// All this copies the data into the pixmap for display in the window
	// There has got to be a MUCH better way to do this, but I don't know it :(
	GC gc = DefaultGC(d, s);
	Colormap cm = DefaultColormap(d, s);
	int idx = 0;
	for(a=0;a<hei;a++)
	for(b=0;b<wid;b++) {
		XColor color;
		color.flags = DoRed|DoGreen|DoBlue;
		color.red = imageData[idx++] << 8;
		color.green = imageData[idx++] << 8;
		color.blue = imageData[idx++] << 8;
		XAllocColor(d, cm, &color);  // FIXME: free the color
		XSetForeground(d, gc, color.pixel);
		XDrawPoint(d, image, gc, b, a);
	}

	// This gives our window a close button
	Atom atom = XInternAtom(d, "WM_DELETE_WINDOW", True); // FIXME: does this need to be freed?
	XSetWMProtocols(d, w, &atom, 1);

	XSelectInput(d, w, ExposureMask | KeyPressMask);
 
	XMapWindow(d, w);
 
	while (1) {
		XNextEvent(d, &e);

		switch(e.type) {
		  case Expose:
			XCopyArea(d, image, w, gc, 0, 0, wid, hei, 0, 0);
		  break;
		  case ClientMessage: // User clicked the close button
		  case KeyPress:
			goto done;
		  break;
		}
	}

    done:
	XFreePixmap(d, image);
	XDestroyWindow(d, w);
	XCloseDisplay(d);
 	return 0;
}
